import json
from .BaseObject import BaseObject
class Vulnerability(BaseObject):
  def __init__(self, api_key):
    BaseObject.__init__(self, api_key)
    self.cpes = None
    self.created_at = None
    self.cve_description = None
    self.cve_id = None
    self.cve_severity = None
    self.domain = None
    self.ip_addresses = None
    self.verified = None
  def from_dict(self, d):
    if 'cpes' in d:
      self.cpes = d['cpes']
    if 'created_at' in d:
      self.created_at = d['created_at']
    if 'cve_description' in d:
      self.cve_description = d['cve_description']
    if 'cve_id' in d:
      self.cve_id = d['cve_id']
    if 'cve_severity' in d:
      self.cve_severity = d['cve_severity']
    if 'domain' in d:
      self.domain = d['domain']
    if 'ip_addresses' in d:
      self.ip_addresses = d['ip_addresses']
    if 'verified' in d:
      self.verified = d['verified']
  def to_dict(self):
    d = {}
    d['cpes'] = self.cpes
    d['created_at'] = self.created_at
    d['cve_description'] = self.cve_description
    d['cve_id'] = self.cve_id
    d['cve_severity'] = self.cve_severity
    d['domain'] = self.domain
    d['ip_addresses'] = self.ip_addresses
    d['verified'] = self.verified
    return d
  def to_json(self):
    d = self.to_dict()
    return json.dumps(d)
